// drottestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "drotdll.h"
#include "drottest.h"
#include "drottestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDrottestDlg dialog

CDrottestDlg::CDrottestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDrottestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDrottestDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pRot = NULL ;
}


void CDrottestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDrottestDlg)
	DDX_Control(pDX, IDC_LIST1, m_List);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDrottestDlg, CDialog)
	//{{AFX_MSG_MAP(CDrottestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CONNECT, OnConnect)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDrottestDlg message handlers

BOOL CDrottestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	CoInitialize (NULL) ;

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDrottestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDrottestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDrottestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


const IID IID_IRemoteROT = {0x23901471,0xFD2A,0x11D0,{0x80,0x6E,0x00,0x60,0x97,0x41,0x8C,0x73}};
const CLSID CLSID_RemoteROT = {0x23901472,0xFD2A,0x11D0,{0x80,0x6E,0x00,0x60,0x97,0x41,0x8C,0x73}};

void CDrottestDlg::OnConnect() 
{

/*
If there is a previous running object table pointer, then release it.
*/

	if (m_pRot != NULL)
	{
		m_pRot->Release( ) ;
	}

/*
Create remote running object table server on specified machine.
*/

	CString RemoteSystemName ;

	GetDlgItemText (IDC_REMOTENAME, RemoteSystemName) ;

	USES_CONVERSION ;

	HRESULT hr ;
	COSERVERINFO si ;

	si.dwReserved1 = 0 ;
	si.pwszName = A2W(RemoteSystemName) ;
	si.pAuthInfo = NULL ;
	si.dwReserved2 = 0 ;

	MULTI_QI mqi [1] ;

	mqi [0].pIID = &IID_IRemoteROT ;
	mqi [0].pItf = NULL ;
	mqi [0].hr = 0 ;

	hr = CoCreateInstanceEx (
		CLSID_RemoteROT,
		NULL, 
		CLSCTX_REMOTE_SERVER,
		&si,
		1,
		mqi) ;

	if (hr != S_OK)
	{
		char out [256] ;
		wsprintf (out, "Couldn't launch remote server, hr == 0x%x", hr) ;
		MessageBox (out, "RemoteROT") ;
	}

	IRemoteROT *pGet = (IRemoteROT *) mqi [0].pItf ;

	hr = pGet->GetRemoteRunningObjectTable (&m_pRot) ;

	pGet->Release ( ) ;

	if (hr != S_OK) 
	{
		CString out ;
		out.Format ("Couldn't get remote running object table, hr == 0x%x", hr) ;
		AfxMessageBox (out) ;
	}
/*
Iterate through running object table. Get each moniker's display name and place in
the list box for the user to see.
First, get the enumerator of all the objects in the running object table.
*/

	IEnumMoniker *pEnum ;

	hr = m_pRot->EnumRunning (&pEnum) ;

/*
Step through each moniker it
*/

	IMoniker *pMoniker ;

	while ((hr = pEnum->Next (1, &pMoniker, NULL)) == S_OK)
	{
		IBindCtx *pBindCtx ;
		CreateBindCtx (0, &pBindCtx) ;

		WCHAR wout [256], *pwout ;
		pwout = wout ;
/*
Get display name from moniker
*/

		pMoniker->GetDisplayName (pBindCtx, NULL, &pwout) ;
/*
Place in list box
*/
		m_List.AddString (W2A(pwout)) ;

/*
Clean up.
*/

		pBindCtx->Release ( ) ;
		pMoniker->Release ( ) ;
	}

	if (pEnum)
	{
		pEnum->Release() ;
	}

}

void CDrottestDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	if (m_pRot)
	{
		m_pRot->Release( ) ;
	}
}
